/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.rcsbusinessmessaging.v1.model;

/**
 * Carousel of cards.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the RCS Business Messaging API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CarouselCard extends com.google.api.client.json.GenericJson {

  /**
   * The list of contents for each card in the carousel. A carousel can have a minimum of 2 cards
   * and a maximum 10 cards.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<CardContent> cardContents;

  /**
   * The width of the cards in the carousel.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String cardWidth;

  /**
   * The list of contents for each card in the carousel. A carousel can have a minimum of 2 cards
   * and a maximum 10 cards.
   * @return value or {@code null} for none
   */
  public java.util.List<CardContent> getCardContents() {
    return cardContents;
  }

  /**
   * The list of contents for each card in the carousel. A carousel can have a minimum of 2 cards
   * and a maximum 10 cards.
   * @param cardContents cardContents or {@code null} for none
   */
  public CarouselCard setCardContents(java.util.List<CardContent> cardContents) {
    this.cardContents = cardContents;
    return this;
  }

  /**
   * The width of the cards in the carousel.
   * @return value or {@code null} for none
   */
  public java.lang.String getCardWidth() {
    return cardWidth;
  }

  /**
   * The width of the cards in the carousel.
   * @param cardWidth cardWidth or {@code null} for none
   */
  public CarouselCard setCardWidth(java.lang.String cardWidth) {
    this.cardWidth = cardWidth;
    return this;
  }

  @Override
  public CarouselCard set(String fieldName, Object value) {
    return (CarouselCard) super.set(fieldName, value);
  }

  @Override
  public CarouselCard clone() {
    return (CarouselCard) super.clone();
  }

}
